import attachSlimSelectTo from 'helpers/attach_slimselect';
import { isEmailAddress } from 'helpers/emails';
import BaseForm from 'controllers/base_form_controller';

export default class extends BaseForm {
  static targets = ['recipientSelect', 'submitButton'];

  connect() {
    super.connect();

    this.detachSlimSelects = [];
    this.recipientSelectTargets.forEach(el => {
      const detachCallback = attachSlimSelectTo(el, {
        events: {
          addable: value => {
            return isEmailAddress(value) && value;
          },
        },
      });

      this.detachSlimSelects.push(detachCallback);
    });
  }

  disconnect() {
    super.disconnect();

    this.detachSlimSelects.forEach(callback => callback(this));
  }
}
